module PostcodeInfo
  class APIExceptionWrapper < Exception
    attr_accessor :original_exception, :response

    def initialize(original_exception, response)
      self.original_exception = original_exception
      self.response = response
    end
  end

  class ServiceUnavailable < APIExceptionWrapper; end
  class ServerError < APIExceptionWrapper; end
  class UnparseableResponse < APIExceptionWrapper; end
  class InvalidAuthToken < APIExceptionWrapper; end
  class UnrecognisedPostcode < APIExceptionWrapper; end
end